def shop_address(shop_id, shelf_id):
    return 0xC71ED0 + (0x40 * shop_id) + (0x08 * shelf_id)

#   Location:                                           Type          Scene Default Addresses                 Categories
location_table = {
    "Kokiri Sword Chest":                              ("Chest",       0x55,  0x00, None,                     ("Kokiri Forest", "Forest",)),
    "Mido Chest Top Left":                             ("Chest",       0x28,  0x00, None,                     ("Kokiri Forest", "Forest",)),
    "Mido Chest Top Right":                            ("Chest",       0x28,  0x01, None,                     ("Kokiri Forest", "Forest",)),
    "Mido Chest Bottom Left":                          ("Chest",       0x28,  0x02, None,                     ("Kokiri Forest", "Forest",)),
    "Mido Chest Bottom Right":                         ("Chest",       0x28,  0x03, None,                     ("Kokiri Forest", "Forest",)),
    "Shield Grave Chest":                              ("Chest",       0x40,  0x00, None,                     ("the Graveyard", "Kakariko",)),
    "Heart Piece Grave Chest":                         ("Chest",       0x3F,  0x00, None,                     ("the Graveyard", "Kakariko",)),
    "Composer Grave Chest":                            ("Chest",       0x41,  0x00, None,                     ("the Graveyard", "Kakariko",)),
    "Death Mountain Bombable Chest":                   ("Chest",       0x60,  0x01, None,                     ("Death Mountain Trail", "Death Mountain",)),
    "Goron City Leftmost Maze Chest":                  ("Chest",       0x62,  0x00, None,                     ("Goron City",)),
    "Goron City Right Maze Chest":                     ("Chest",       0x62,  0x01, None,                     ("Goron City",)),
    "Goron City Left Maze Chest":                      ("Chest",       0x62,  0x02, None,                     ("Goron City",)),
    "Zoras Domain Torch Run":                          ("Chest",       0x58,  0x00, None,                     ("Zora's Domain", )),
    "Hookshot Chest":                                  ("Chest",       0x48,  0x00, None,                     ("the Graveyard", "Kakariko",)),
    "Gerudo Valley Hammer Rocks Chest":                ("Chest",       0x5A,  0x00, None,                     ("Gerudo Valley", "Gerudo",)),
    "Gerudo Fortress Rooftop Chest":                   ("Chest",       0x5D,  0x00, None,                     ("Gerudo's Fortress", "Gerudo",)),
    "Haunted Wasteland Structure Chest":               ("Chest",       0x5E,  0x00, None,                     ("Haunted Wasteland",)),
    "Redead Grotto Chest":                             ("Chest",       0x3E,  0x0A, None,                     ("Kakariko Village", "Kakariko", "Grottos")),
    "Wolfos Grotto Chest":                             ("Chest",       0x3E,  0x11, None,                     ("Sacred Forest Meadow", "Forest", "Grottos")),
    "Field West Castle Town Grotto Chest":             ("Chest",       0x3E,  0x00, None,                     ("Hyrule Field", "Grottos",)),
    "Remote Southern Grotto Chest":                    ("Chest",       0x3E,  0x02, None,                     ("Hyrule Field", "Grottos",)),
    "Field Near Lake Outside Fence Grotto Chest":      ("Chest",       0x3E,  0x03, None,                     ("Hyrule Field", "Grottos",)),
    "Kakariko Back Grotto Chest":                      ("Chest",       0x3E,  0x08, None,                     ("Kakariko Village", "Kakariko", "Grottos")),
    "Zora River Plateau Open Grotto Chest":            ("Chest",       0x3E,  0x09, None,                     ("Zora's River", "Grottos",)),
    "Kokiri Forest Storms Grotto Chest":               ("Chest",       0x3E,  0x0C, None,                     ("Kokiri Forest", "Forest", "Grottos")),
    "Lost Woods Generic Grotto Chest":                 ("Chest",       0x3E,  0x14, None,                     ("the Lost Woods", "Forest", "Grottos")),
    "Mountain Storms Grotto Chest":                    ("Chest",       0x3E,  0x17, None,                     ("Death Mountain Trail", "Death Mountain", "Grottos")),
    "Top of Crater Grotto Chest":                      ("Chest",       0x3E,  0x1A, None,                     ("Death Mountain Crater", "Death Mountain", "Grottos")),
    "Treasure Chest Game":                             ("Chest",       0x10,  0x0A, None,                     ("the Market", "Castle Town", "Minigames")),

    "Zelda":                                           ("Cutscene",    0xFF,  0x01, None,                     ("Temple of Time", "Castle Town",)),
    "Gift from Saria":                                 ("Cutscene",    0xFF,  0x02, None,                     ("the Lost Woods", "Forest",)),
    "Zoras Fountain Fairy Reward":                     ("Cutscene",    0xFF,  0x10, None,                     ("Zora's Fountain", "Fairies",)),
    "Hyrule Castle Fairy Reward":                      ("Cutscene",    0xFF,  0x11, None,                     ("Hyrule Castle", "Castle Town", "Fairies")),
    "Desert Colossus Fairy Reward":                    ("Cutscene",    0xFF,  0x12, None,                     ("Desert Colossus", "Fairies",)),
    "Mountain Summit Fairy Reward":                    ("Cutscene",    0xFF,  0x13, None,                     ("Death Mountain Trail", "Death Mountain", "Fairies")),
    "Crater Fairy Reward":                             ("Cutscene",    0xFF,  0x14, None,                     ("Death Mountain Crater", "Death Mountain", "Fairies",)),
    "Ganons Castle Fairy Reward":                      ("Cutscene",    0xFF,  0x15, None,                     ("outside Ganon's Castle", "Castle Town", "Fairies")),

    "Sheik Forest Song":                               ("Song",        0xFF,  0x20, (0x20B0809, 0x20B0809),   ("Sacred Forest Meadow", "Forest", "Songs")),
    "Sheik in Crater":                                 ("Song",        0xFF,  0x21, (0x224D7F1, 0x224D7F1),   ("Death Mountain Crater", "Death Mountain", "Songs")),
    "Sheik in Ice Cavern":                             ("Song",        0xFF,  0x22, (0x2BEC889, 0x2BEC889),   ("Ice Cavern", "Songs",)),
    "Sheik at Colossus":                               ("Song",        0xFF,  0x23, (0x218C57D, 0x218C57D),   ("Desert Colossus", "Songs",)),
    "Sheik in Kakariko":                               ("Song",        0xFF,  0x24, (0x2000FE1, 0x2000FE1),   ("Kakariko Village", "Kakariko", "Songs")),
    "Sheik at Temple":                                 ("Song",        0xFF,  0x25, (0x2531329, 0x2531329),   ("Temple of Time", "Castle Town", "Songs")),
    "Impa at Castle":                                  ("Song",        0xFF,  0x26, (0x2E8E925, 0x2E8E925),   ("Hyrule Castle", "Castle Town", "Songs")),
    "Song from Malon":                                 ("Song",        0xFF,  0x27, (0x0D7EB53, 0x0D7EBCF),   ("Lon Lon Ranch", "Songs",)),
    "Song from Saria":                                 ("Song",        0xFF,  0x28, (0x20B1DB1, 0x20B1DB1),   ("Sacred Forest Meadow", "Forest", "Songs")),
    "Song from Composer Grave":                        ("Song",        0xFF,  0x29, (0x332A871, 0x332A871),   ("the Graveyard", "Kakariko", "Songs")),
    "Song from Ocarina of Time":                       ("Song",        0xFF,  0x2A, (0x252FC89, 0x252FC89),   ("Hyrule Field", "Songs", "Need Spiritual Stones")),
    "Song at Windmill":                                ("Song",        0xFF,  0x2B, (0x0E42C07, 0x0E42B8B),   ("Kakariko Village", "Kakariko", "Songs")),

    "Malon Egg":                                       ("NPC",         0x5F,  0x47, None,                     ("Hyrule Castle", "Castle Town",)),
    "Zeldas Letter":                                   ("NPC",         None,  None, None,                     ("Hyrule Castle", "Castle Town",)),
    "Darunias Joy":                                    ("NPC",         0x62,  0x54, None,                     ("Goron City",)),
    "Diving Minigame":                                 ("NPC",         0x58,  0x37, None,                     ("Zora's Domain", "Minigames",)),
    "Child Fishing":                                   ("NPC",         0x49,  0x3E, None,                     ("Lake Hylia", "Minigames",)),
    "Adult Fishing":                                   ("NPC",         0x49,  0x38, None,                     ("Lake Hylia", "Minigames",)),
    "Diving in the Lab":                               ("NPC",         0x38,  0x3E, None,                     ("Lake Hylia",)),
    "Link the Goron":                                  ("NPC",         0x62,  0x2C, None,                     ("Goron City",)),
    "King Zora Thawed":                                ("NPC",         0x58,  0x2D, None,                     ("Zora's Domain",)),
    "Bombchu Bowling Bomb Bag":                        ("NPC",         0x4B,  0x34, None,                     ("the Market", "Castle Town", "Minigames")),
    "Bombchu Bowling Piece of Heart":                  ("NPC",         0x4B,  0x3E, None,                     ("the Market", "Castle Town", "Minigames")),
    "Bombchu Bowling Bombchus":                        ("NPC",         0x4B,  None, None,                     ("the Market", "Castle Town", "Minigames")),
    "Dog Lady":                                        ("NPC",         0x35,  0x3E, None,                     ("the Market", "Castle Town",)),
    "Skull Kid":                                       ("NPC",         0x5B,  0x3E, None,                     ("the Lost Woods", "Forest",)),
    "Ocarina Memory Game":                             ("NPC",         0x5B,  0x76, None,                     ("the Lost Woods", "Forest", "Minigames")),
    "10 Gold Skulltula Reward":                        ("NPC",         0x50,  0x45, None,                     ("Kakariko Village", "Kakariko", "Skulltula House")),
    "20 Gold Skulltula Reward":                        ("NPC",         0x50,  0x39, None,                     ("Kakariko Village", "Kakariko", "Skulltula House")),
    "30 Gold Skulltula Reward":                        ("NPC",         0x50,  0x46, None,                     ("Kakariko Village", "Kakariko", "Skulltula House")),
    "40 Gold Skulltula Reward":                        ("NPC",         0x50,  0x03, None,                     ("Kakariko Village", "Kakariko", "Skulltula House")),
    "50 Gold Skulltula Reward":                        ("NPC",         0x50,  0x3E, None,                     ("Kakariko Village", "Kakariko", "Skulltula House")),
    "Man on Roof":                                     ("NPC",         0x52,  0x3E, None,                     ("Kakariko Village", "Kakariko",)),
    "Magic Bean Salesman":                             ("NPC",         0x54,  0x16, None,                     ("Zora's River",)),
    "Frog Ocarina Game":                               ("NPC",         0x54,  0x76, None,                     ("Zora's River",)),
    "Frogs in the Rain":                               ("NPC",         0x54,  0x3E, None,                     ("Zora's River", "Minigames",)),
    "Horseback Archery 1000 Points":                   ("NPC",         0x5D,  0x3E, None,                     ("Gerudo's Fortress", "Gerudo", "Minigames")),
    "Horseback Archery 1500 Points":                   ("NPC",         0x5D,  0x30, None,                     ("Gerudo's Fortress", "Gerudo", "Minigames")),
    "Child Shooting Gallery":                          ("NPC",         0x42,  0x60, None,                     ("the Market", "Castle Town", "Minigames")),
    "Adult Shooting Gallery":                          ("NPC",         0x42,  0x30, None,                     ("Kakariko Village", "Kakariko", "Minigames")),
    "Target in Woods":                                 ("NPC",         0x5B,  0x60, None,                     ("the Lost Woods", "Forest",)),
    "Deku Theater Skull Mask":                         ("NPC",         0x3E,  0x77, None,                     ("the Lost Woods", "Forest", "Grottos")),
    "Deku Theater Mask of Truth":                      ("NPC",         0x3E,  0x7A, None,                     ("the Lost Woods", "Forest", "Need Spiritual Stones", "Grottos")),
    "Anju as Adult":                                   ("NPC",         0x52,  0x1D, None,                     ("Kakariko Village", "Kakariko",)),
    "Biggoron":                                        ("NPC",         0x60,  0x57, None,                     ("Death Mountain Trail", "Death Mountain",)),
    "Anjus Chickens":                                  ("NPC",         0x52,  0x0F, None,                     ("Kakariko Village", "Kakariko", "Minigames")),
    "Talons Chickens":                                 ("NPC",         0x4C,  0x14, None,                     ("Lon Lon Ranch", "Kakariko", "Minigames")),
    "10 Big Poes":                                     ("NPC",         0x4D,  0x0F, None,                     ("the Market", "Hyrule Castle",)),
    "Rolling Goron as Child":                          ("NPC",         0x62,  0x34, None,                     ("Goron City",)),
    "Underwater Bottle":                               ("NPC",         0x57,  0x15, None,                     ("Lake Hylia",)),
    "Lake Hylia Sun":                                  ("NPC",         0x57,  0x58, None,                     ("Lake Hylia",)),
    "Gerudo Fortress Membership Card":                 ("NPC",         0x0C,  0x3A, None,                     ("Gerudo's Fortress", "Gerudo",)),
    "Ocarina of Time":                                 ("NPC",         0x51,  0x0C, None,                     ("Hyrule Field", "Need Spiritual Stones",)),
    "Haunted Wasteland Bombchu Salesman":              ("NPC",         None,  None, None,                     ("Haunted Wasteland",)),

    "Impa House Freestanding PoH":                     ("Collectable", 0x37,  0x01, None,                     ("Kakariko Village", "Kakariko",)),
    "Tektite Grotto Freestanding PoH":                 ("Collectable", 0x3E,  0x01, None,                     ("Hyrule Field", "Grottos",)),
    "Windmill Freestanding PoH":                       ("Collectable", 0x48,  0x01, None,                     ("Kakariko Village", "Kakariko",)),
    "Dampe Race Freestanding PoH":                     ("Collectable", 0x48,  0x07, None,                     ("the Graveyard", "Kakariko", "Minigames")),
    "Lon Lon Tower Freestanding PoH":                  ("Collectable", 0x4C,  0x01, None,                     ("Lon Lon Ranch",)),
    "Graveyard Freestanding PoH":                      ("Collectable", 0x53,  0x04, None,                     ("the Graveyard", "Kakariko",)),
    "Gravedigging Tour":                               ("Collectable", 0x53,  0x08, None,                     ("the Graveyard", "Kakariko",)),
    "Zora River Lower Freestanding PoH":               ("Collectable", 0x54,  0x04, None,                     ("Zora's River",)),
    "Zora River Upper Freestanding PoH":               ("Collectable", 0x54,  0x0B, None,                     ("Zora's River",)),
    "Lake Hylia Freestanding PoH":                     ("Collectable", 0x57,  0x1E, None,                     ("Lake Hylia",)),
    "Zoras Fountain Iceberg Freestanding PoH":         ("Collectable", 0x59,  0x01, None,                     ("Zora's Fountain",)),
    "Zoras Fountain Bottom Freestanding PoH":          ("Collectable", 0x59,  0x14, None,                     ("Zora's Fountain",)),
    "Gerudo Valley Waterfall Freestanding PoH":        ("Collectable", 0x5A,  0x01, None,                     ("Gerudo Valley", "Gerudo",)),
    "Gerudo Valley Crate Freestanding PoH":            ("Collectable", 0x5A,  0x02, None,                     ("Gerudo Valley", "Gerudo",)),
    "Colossus Freestanding PoH":                       ("Collectable", 0x5C,  0x0D, None,                     ("Desert Colossus",)),
    "DM Trail Freestanding PoH":                       ("Collectable", 0x60,  0x1E, None,                     ("Death Mountain Trail", "Death Mountain",)),
    "DM Crater Wall Freestanding PoH":                 ("Collectable", 0x61,  0x02, None,                     ("Death Mountain Crater", "Death Mountain",)),
    "DM Crater Volcano Freestanding PoH":              ("Collectable", 0x61,  0x08, None,                     ("Death Mountain Crater", "Death Mountain",)),
    "Goron City Pot Freestanding PoH":                 ("Collectable", 0x62,  0x1F, None,                     ("Goron City", "Goron City",)),
    "Gerudo Fortress North F1 Carpenter":              ("Collectable", 0x0C,  0x0C, None,                     ("Gerudo's Fortress", "Gerudo",)),
    "Gerudo Fortress North F2 Carpenter":              ("Collectable", 0x0C,  0x0A, None,                     ("Gerudo's Fortress", "Gerudo",)),
    "Gerudo Fortress South F1 Carpenter":              ("Collectable", 0x0C,  0x0E, None,                     ("Gerudo's Fortress", "Gerudo",)),
    "Gerudo Fortress South F2 Carpenter":              ("Collectable", 0x0C,  0x0F, None,                     ("Gerudo's Fortress", "Gerudo",)),

    "Pierre":                                          ("Event",       None,  None, None,                     None),
    "Deliver Ruto's Letter":                           ("Event",       None,  None, None,                     None),
    "Master Sword Pedestal":                           ("Event",       None,  None, None,                     None),

    "Deku Baba Sticks":                                ("Drop",        None,  None, None,                     None),
    "Deku Baba Nuts":                                  ("Drop",        None,  None, None,                     None),
    "Stick Pot":                                       ("Drop",        None,  None, None,                     None),
    "Nut Pot":                                         ("Drop",        None,  None, None,                     None),
    "Nut Crate":                                       ("Drop",        None,  None, None,                     None),
    "Blue Fire":                                       ("Drop",        None,  None, None,                     None),
    "Lone Fish":                                       ("Drop",        None,  None, None,                     None),
    "Fish Group":                                      ("Drop",        None,  None, None,                     None),
    "Bug Rock":                                        ("Drop",        None,  None, None,                     None),
    "Bug Shrub":                                       ("Drop",        None,  None, None,                     None),
    "Wandering Bugs":                                  ("Drop",        None,  None, None,                     None),
    "Fairy Pot":                                       ("Drop",        None,  None, None,                     None),
    "Free Fairies":                                    ("Drop",        None,  None, None,                     None),
    "Wall Switch Fairy":                               ("Drop",        None,  None, None,                     None),
    "Butterfly Fairy":                                 ("Drop",        None,  None, None,                     None),
    "Gossip Stone Fairy":                              ("Drop",        None,  None, None,                     None),
    "Bean Plant Fairy":                                ("Drop",        None,  None, None,                     None),
    "Fairy Pond":                                      ("Drop",        None,  None, None,                     None),
    "Big Poe Kill":                                    ("Drop",        None,  None, None,                     None),

    # Deku Tree vanilla
    "Deku Tree Lobby Chest":                           ("Chest",       0x00,  0x03, None,                     ("Deku Tree",)),
    "Deku Tree Slingshot Chest":                       ("Chest",       0x00,  0x01, None,                     ("Deku Tree",)),
    "Deku Tree Slingshot Room Side Chest":             ("Chest",       0x00,  0x05, None,                     ("Deku Tree",)),
    "Deku Tree Compass Chest":                         ("Chest",       0x00,  0x02, None,                     ("Deku Tree",)),
    "Deku Tree Compass Room Side Chest":               ("Chest",       0x00,  0x06, None,                     ("Deku Tree",)),
    "Deku Tree Basement Chest":                        ("Chest",       0x00,  0x04, None,                     ("Deku Tree",)),
    # Deku Tree MQ
    "Deku Tree MQ Lobby Chest":                        ("Chest",       0x00,  0x03, None,                     ("Deku Tree",)),
    "Deku Tree MQ Compass Chest":                      ("Chest",       0x00,  0x01, None,                     ("Deku Tree",)),
    "Deku Tree MQ Slingshot Chest":                    ("Chest",       0x00,  0x06, None,                     ("Deku Tree",)),
    "Deku Tree MQ Slingshot Room Back Chest":          ("Chest",       0x00,  0x02, None,                     ("Deku Tree",)),
    "Deku Tree MQ Basement Chest":                     ("Chest",       0x00,  0x04, None,                     ("Deku Tree",)),
    "Deku Tree MQ Before Spinning Log Chest":          ("Chest",       0x00,  0x05, None,                     ("Deku Tree",)),
    "Deku Tree MQ After Spinning Log Chest":           ("Chest",       0x00,  0x00, None,                     ("Deku Tree",)),

    # Dodongo's Cavern shared
    "Chest Above King Dodongo":                        ("Chest",       0x12,  0x00, None,                     ("Dodongo's Cavern",)),
    # Dodongo's Cavern vanilla
    "Dodongos Cavern Map Chest":                       ("Chest",       0x01,  0x08, None,                     ("Dodongo's Cavern",)),
    "Dodongos Cavern Compass Chest":                   ("Chest",       0x01,  0x05, None,                     ("Dodongo's Cavern",)),
    "Dodongos Cavern Bomb Flower Platform":            ("Chest",       0x01,  0x06, None,                     ("Dodongo's Cavern",)),
    "Dodongos Cavern Bomb Bag Chest":                  ("Chest",       0x01,  0x04, None,                     ("Dodongo's Cavern",)),
    "Dodongos Cavern End of Bridge Chest":             ("Chest",       0x01,  0x0A, None,                     ("Dodongo's Cavern",)),
    # Dodongo's Cavern MQ
    "Dodongos Cavern MQ Map Chest":                    ("Chest",       0x01,  0x00, None,                     ("Dodongo's Cavern",)),
    "Dodongos Cavern MQ Bomb Bag Chest":               ("Chest",       0x01,  0x04, None,                     ("Dodongo's Cavern",)),
    "Dodongos Cavern MQ Compass Chest":                ("Chest",       0x01,  0x05, None,                     ("Dodongo's Cavern",)),
    "Dodongos Cavern MQ Larva Room Chest":             ("Chest",       0x01,  0x02, None,                     ("Dodongo's Cavern",)),
    "Dodongos Cavern MQ Torch Puzzle Room Chest":      ("Chest",       0x01,  0x03, None,                     ("Dodongo's Cavern",)),
    "Dodongos Cavern MQ Under Grave Chest":            ("Chest",       0x01,  0x01, None,                     ("Dodongo's Cavern",)),

    # Jabu Jabu's Belly vanilla
    "Boomerang Chest":                                 ("Chest",       0x02,  0x01, None,                     ("Jabu Jabu's Belly",)),
    "Jabu Jabus Belly Map Chest":                      ("Chest",       0x02,  0x02, None,                     ("Jabu Jabu's Belly",)),
    "Jabu Jabus Belly Compass Chest":                  ("Chest",       0x02,  0x04, None,                     ("Jabu Jabu's Belly",)),
    # Jabu Jabu's Belly MQ
    "Jabu Jabus Belly MQ Entry Side Chest":            ("Chest",       0x02,  0x05, None,                     ("Jabu Jabu's Belly",)),
    "Jabu Jabus Belly MQ Map Chest":                   ("Chest",       0x02,  0x03, None,                     ("Jabu Jabu's Belly",)),
    "Jabu Jabus Belly MQ Second Room Lower Chest":     ("Chest",       0x02,  0x02, None,                     ("Jabu Jabu's Belly",)),
    "Jabu Jabus Belly MQ Compass Chest":               ("Chest",       0x02,  0x00, None,                     ("Jabu Jabu's Belly",)),
    "Jabu Jabus Belly MQ Second Room Upper Chest":     ("Chest",       0x02,  0x07, None,                     ("Jabu Jabu's Belly",)),
    "Jabu Jabus Belly MQ Basement North Chest":        ("Chest",       0x02,  0x08, None,                     ("Jabu Jabu's Belly",)),
    "Jabu Jabus Belly MQ Basement South Chest":        ("Chest",       0x02,  0x04, None,                     ("Jabu Jabu's Belly",)),
    "Jabu Jabus Belly MQ Near Boss Chest":             ("Chest",       0x02,  0x0A, None,                     ("Jabu Jabu's Belly",)),
    "Jabu Jabus Belly MQ Falling Like Like Room Chest":("Chest",       0x02,  0x09, None,                     ("Jabu Jabu's Belly",)),
    "Jabu Jabus Belly MQ Boomerang Room Small Chest":  ("Chest",       0x02,  0x01, None,                     ("Jabu Jabu's Belly",)),
    "MQ Boomerang Chest":                              ("Chest",       0x02,  0x06, None,                     ("Jabu Jabu's Belly",)),
    "Jabu Jabus Belly MQ Cow":                         ("NPC",         0x02,  0x15, None,                     ("Jabu Jabu's Belly", "Cow",)),

    # Forest Temple vanilla
    "Forest Temple First Chest":                       ("Chest",       0x03,  0x03, None,                     ("Forest Temple",)),
    "Forest Temple Chest Behind Lobby":                ("Chest",       0x03,  0x00, None,                     ("Forest Temple",)),
    "Forest Temple Well Chest":                        ("Chest",       0x03,  0x09, None,                     ("Forest Temple",)),
    "Forest Temple Map Chest":                         ("Chest",       0x03,  0x01, None,                     ("Forest Temple",)),
    "Forest Temple Outside Hookshot Chest":            ("Chest",       0x03,  0x05, None,                     ("Forest Temple",)),
    "Forest Temple Falling Room Chest":                ("Chest",       0x03,  0x07, None,                     ("Forest Temple",)),
    "Forest Temple Block Push Chest":                  ("Chest",       0x03,  0x04, None,                     ("Forest Temple",)),
    "Forest Temple Boss Key Chest":                    ("Chest",       0x03,  0x0E, None,                     ("Forest Temple",)),
    "Forest Temple Floormaster Chest":                 ("Chest",       0x03,  0x02, None,                     ("Forest Temple",)),
    "Forest Temple Bow Chest":                         ("Chest",       0x03,  0x0C, None,                     ("Forest Temple",)),
    "Forest Temple Red Poe Chest":                     ("Chest",       0x03,  0x0D, None,                     ("Forest Temple",)),
    "Forest Temple Blue Poe Chest":                    ("Chest",       0x03,  0x0F, None,                     ("Forest Temple",)),
    "Forest Temple Near Boss Chest":                   ("Chest",       0x03,  0x0B, None,                     ("Forest Temple",)),
    # Forest Temple MQ
    "Forest Temple MQ First Chest":                    ("Chest",       0x03,  0x03, None,                     ("Forest Temple",)),
    "Forest Temple MQ Chest Behind Lobby":             ("Chest",       0x03,  0x00, None,                     ("Forest Temple",)),
    "Forest Temple MQ Bow Chest":                      ("Chest",       0x03,  0x0C, None,                     ("Forest Temple",)),
    "Forest Temple MQ NE Outdoors Lower Chest":        ("Chest",       0x03,  0x01, None,                     ("Forest Temple",)),
    "Forest Temple MQ NE Outdoors Upper Chest":        ("Chest",       0x03,  0x05, None,                     ("Forest Temple",)),
    "Forest Temple MQ Well Chest":                     ("Chest",       0x03,  0x09, None,                     ("Forest Temple",)),
    "Forest Temple MQ Map Chest":                      ("Chest",       0x03,  0x0D, None,                     ("Forest Temple",)),
    "Forest Temple MQ Compass Chest":                  ("Chest",       0x03,  0x0F, None,                     ("Forest Temple",)),
    "Forest Temple MQ Falling Room Chest":             ("Chest",       0x03,  0x06, None,                     ("Forest Temple",)),
    "Forest Temple MQ Near Boss Chest":                ("Chest",       0x03,  0x0B, None,                     ("Forest Temple",)),
    "Forest Temple MQ Redead Chest":                   ("Chest",       0x03,  0x02, None,                     ("Forest Temple",)),
    "Forest Temple MQ Boss Key Chest":                 ("Chest",       0x03,  0x0E, None,                     ("Forest Temple",)),

    # Fire Temple vanilla
    "Fire Temple Chest Near Boss":                     ("Chest",       0x04,  0x01, None,                     ("Fire Temple",)),
    "Fire Temple Fire Dancer Chest":                   ("Chest",       0x04,  0x00, None,                     ("Fire Temple",)),
    "Fire Temple Boss Key Chest":                      ("Chest",       0x04,  0x0C, None,                     ("Fire Temple",)),
    "Fire Temple Big Lava Room Bombable Chest":        ("Chest",       0x04,  0x02, None,                     ("Fire Temple",)),
    "Fire Temple Big Lava Room Open Chest":            ("Chest",       0x04,  0x04, None,                     ("Fire Temple",)),
    "Fire Temple Boulder Maze Lower Chest":            ("Chest",       0x04,  0x03, None,                     ("Fire Temple",)),
    "Fire Temple Boulder Maze Upper Chest":            ("Chest",       0x04,  0x06, None,                     ("Fire Temple",)),
    "Fire Temple Boulder Maze Side Room":              ("Chest",       0x04,  0x08, None,                     ("Fire Temple",)),
    "Fire Temple Boulder Maze Bombable Pit":           ("Chest",       0x04,  0x0B, None,                     ("Fire Temple",)),
    "Fire Temple Scarecrow Chest":                     ("Chest",       0x04,  0x0D, None,                     ("Fire Temple",)),
    "Fire Temple Map Chest":                           ("Chest",       0x04,  0x0A, None,                     ("Fire Temple",)),
    "Fire Temple Compass Chest":                       ("Chest",       0x04,  0x07, None,                     ("Fire Temple",)),
    "Fire Temple Highest Goron Chest":                 ("Chest",       0x04,  0x09, None,                     ("Fire Temple",)),
    "Fire Temple Megaton Hammer Chest":                ("Chest",       0x04,  0x05, None,                     ("Fire Temple",)),
    # Fire Temple MQ
    "Fire Temple MQ Chest Near Boss":                  ("Chest",       0x04,  0x07, None,                     ("Fire Temple",)),
    "Fire Temple MQ Megaton Hammer Chest":             ("Chest",       0x04,  0x00, None,                     ("Fire Temple",)),
    "Fire Temple MQ Compass Chest":                    ("Chest",       0x04,  0x0B, None,                     ("Fire Temple",)),
    "Fire Temple MQ Maze Lower Chest":                 ("Chest",       0x04,  0x03, None,                     ("Fire Temple",)),
    "Fire Temple MQ Maze Upper Chest":                 ("Chest",       0x04,  0x06, None,                     ("Fire Temple",)),
    "Fire Temple MQ West Tower Top Chest":             ("Chest",       0x04,  0x05, None,                     ("Fire Temple",)),
    "Fire Temple MQ Entrance Hallway Small Chest":     ("Chest",       0x04,  0x02, None,                     ("Fire Temple",)),
    "Fire Temple MQ Map Chest":                        ("Chest",       0x04,  0x0C, None,                     ("Fire Temple",)),
    "Fire Temple MQ Boss Key Chest":                   ("Chest",       0x04,  0x04, None,                     ("Fire Temple",)),
    "Fire Temple MQ Big Lava Room Bombable Chest":     ("Chest",       0x04,  0x01, None,                     ("Fire Temple",)),
    "Fire Temple MQ Maze Side Room":                   ("Chest",       0x04,  0x08, None,                     ("Fire Temple",)),
    "Fire Temple MQ Freestanding Key":                 ("Collectable", 0x04,  0x1C, None,                     ("Fire Temple",)),

    # Water Temple vanilla
    "Water Temple Map Chest":                          ("Chest",       0x05,  0x02, None,                     ("Water Temple",)),
    "Water Temple Compass Chest":                      ("Chest",       0x05,  0x09, None,                     ("Water Temple",)),
    "Water Temple Torches Chest":                      ("Chest",       0x05,  0x01, None,                     ("Water Temple",)),
    "Water Temple Dragon Chest":                       ("Chest",       0x05,  0x0A, None,                     ("Water Temple",)),
    "Water Temple Central Bow Target Chest":           ("Chest",       0x05,  0x08, None,                     ("Water Temple",)),
    "Water Temple Central Pillar Chest":               ("Chest",       0x05,  0x06, None,                     ("Water Temple",)),
    "Water Temple Cracked Wall Chest":                 ("Chest",       0x05,  0x00, None,                     ("Water Temple",)),
    "Water Temple Boss Key Chest":                     ("Chest",       0x05,  0x05, None,                     ("Water Temple",)),
    "Water Temple Dark Link Chest":                    ("Chest",       0x05,  0x07, None,                     ("Water Temple",)),
    "Water Temple River Chest":                        ("Chest",       0x05,  0x03, None,                     ("Water Temple",)),
    # Water Temple MQ
    "Water Temple MQ Central Pillar Chest":            ("Chest",       0x05,  0x06, None,                     ("Water Temple",)),
    "Water Temple MQ Boss Key Chest":                  ("Chest",       0x05,  0x05, None,                     ("Water Temple",)),
    "Water Temple MQ Longshot Chest":                  ("Chest",       0x05,  0x00, None,                     ("Water Temple",)),
    "Water Temple MQ Compass Chest":                   ("Chest",       0x05,  0x01, None,                     ("Water Temple",)),
    "Water Temple MQ Map Chest":                       ("Chest",       0x05,  0x02, None,                     ("Water Temple",)),
    "Water Temple MQ Freestanding Key":                ("Collectable", 0x05,  0x01, None,                     ("Water Temple",)),

    # Spirit Temple shared
    "Silver Gauntlets Chest":                          ("Chest",       0x5C,  0x0B, None,                     ("Spirit Temple", "Desert Colossus")),
    "Mirror Shield Chest":                             ("Chest",       0x5C,  0x09, None,                     ("Spirit Temple", "Desert Colossus")),
    # Spirit Temple vanilla
    "Spirit Temple Child Left Chest":                  ("Chest",       0x06,  0x08, None,                     ("Spirit Temple",)),
    "Spirit Temple Child Right Chest":                 ("Chest",       0x06,  0x00, None,                     ("Spirit Temple",)),
    "Spirit Temple Compass Chest":                     ("Chest",       0x06,  0x04, None,                     ("Spirit Temple",)),
    "Spirit Temple Early Adult Right Chest":           ("Chest",       0x06,  0x07, None,                     ("Spirit Temple",)),
    "Spirit Temple First Mirror Right Chest":          ("Chest",       0x06,  0x0D, None,                     ("Spirit Temple",)),
    "Spirit Temple First Mirror Left Chest":           ("Chest",       0x06,  0x0E, None,                     ("Spirit Temple",)),
    "Spirit Temple Map Chest":                         ("Chest",       0x06,  0x03, None,                     ("Spirit Temple",)),
    "Spirit Temple Child Climb East Chest":            ("Chest",       0x06,  0x06, None,                     ("Spirit Temple",)),
    "Spirit Temple Child Climb North Chest":           ("Chest",       0x06,  0x0C, None,                     ("Spirit Temple",)),
    "Spirit Temple Sun Block Room Chest":              ("Chest",       0x06,  0x01, None,                     ("Spirit Temple",)),
    "Spirit Temple Statue Hand Chest":                 ("Chest",       0x06,  0x02, None,                     ("Spirit Temple",)),
    "Spirit Temple NE Main Room Chest":                ("Chest",       0x06,  0x0F, None,                     ("Spirit Temple",)),
    "Spirit Temple Near Four Armos Chest":             ("Chest",       0x06,  0x05, None,                     ("Spirit Temple",)),
    "Spirit Temple Hallway Left Invisible Chest":      ("Chest",       0x06,  0x14, None,                     ("Spirit Temple",)),
    "Spirit Temple Hallway Right Invisible Chest":     ("Chest",       0x06,  0x15, None,                     ("Spirit Temple",)),
    "Spirit Temple Boss Key Chest":                    ("Chest",       0x06,  0x0A, None,                     ("Spirit Temple",)),
    "Spirit Temple Topmost Chest":                     ("Chest",       0x06,  0x12, None,                     ("Spirit Temple",)),
    # Spirit Temple MQ
    "Spirit Temple MQ Entrance Front Left Chest":      ("Chest",       0x06,  0x1A, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Entrance Back Right Chest":      ("Chest",       0x06,  0x1F, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Entrance Front Right Chest":     ("Chest",       0x06,  0x1B, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Entrance Back Left Chest":       ("Chest",       0x06,  0x1E, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Child Center Chest":             ("Chest",       0x06,  0x1D, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Map Chest":                      ("Chest",       0x06,  0x00, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Child Left Chest":               ("Chest",       0x06,  0x08, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Child Climb North Chest":        ("Chest",       0x06,  0x06, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Child Climb South Chest":        ("Chest",       0x06,  0x0C, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Compass Chest":                  ("Chest",       0x06,  0x03, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Lower NE Main Room Chest":       ("Chest",       0x06,  0x0F, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Upper NE Main Room Chest":       ("Chest",       0x06,  0x02, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Silver Block Hallway Chest":     ("Chest",       0x06,  0x1C, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Sun Block Room Chest":           ("Chest",       0x06,  0x01, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Lower Adult Right Chest":        ("Chest",       0x06,  0x07, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Lower Adult Left Chest":         ("Chest",       0x06,  0x04, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Beamos Room Chest":              ("Chest",       0x06,  0x19, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Ice Trap Chest":                 ("Chest",       0x06,  0x18, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Boss Key Chest":                 ("Chest",       0x06,  0x05, None,                     ("Spirit Temple",)),
    "Spirit Temple MQ Mirror Puzzle Invisible Chest":  ("Chest",       0x06,  0x12, None,                     ("Spirit Temple",)),

    # Shadow Temple vanilla
    "Shadow Temple Map Chest":                         ("Chest",       0x07,  0x01, None,                     ("Shadow Temple",)),
    "Shadow Temple Hover Boots Chest":                 ("Chest",       0x07,  0x07, None,                     ("Shadow Temple",)),
    "Shadow Temple Compass Chest":                     ("Chest",       0x07,  0x03, None,                     ("Shadow Temple",)),
    "Shadow Temple Early Silver Rupee Chest":          ("Chest",       0x07,  0x02, None,                     ("Shadow Temple",)),
    "Shadow Temple Invisible Blades Visible Chest":    ("Chest",       0x07,  0x0C, None,                     ("Shadow Temple",)),
    "Shadow Temple Invisible Blades Invisible Chest":  ("Chest",       0x07,  0x16, None,                     ("Shadow Temple",)),
    "Shadow Temple Falling Spikes Lower Chest":        ("Chest",       0x07,  0x05, None,                     ("Shadow Temple",)),
    "Shadow Temple Falling Spikes Upper Chest":        ("Chest",       0x07,  0x06, None,                     ("Shadow Temple",)),
    "Shadow Temple Falling Spikes Switch Chest":       ("Chest",       0x07,  0x04, None,                     ("Shadow Temple",)),
    "Shadow Temple Invisible Spikes Chest":            ("Chest",       0x07,  0x09, None,                     ("Shadow Temple",)),
    "Shadow Temple Wind Hint Chest":                   ("Chest",       0x07,  0x15, None,                     ("Shadow Temple",)),
    "Shadow Temple After Wind Enemy Chest":            ("Chest",       0x07,  0x08, None,                     ("Shadow Temple",)),
    "Shadow Temple After Wind Hidden Chest":           ("Chest",       0x07,  0x14, None,                     ("Shadow Temple",)),
    "Shadow Temple Spike Walls Left Chest":            ("Chest",       0x07,  0x0A, None,                     ("Shadow Temple",)),
    "Shadow Temple Boss Key Chest":                    ("Chest",       0x07,  0x0B, None,                     ("Shadow Temple",)),
    "Shadow Temple Hidden Floormaster Chest":          ("Chest",       0x07,  0x0D, None,                     ("Shadow Temple",)),
    "Shadow Temple Freestanding Key":                  ("Collectable", 0x07,  0x01, None,                     ("Shadow Temple",)),
    # Shadow Temple MQ
    "Shadow Temple MQ Compass Chest":                  ("Chest",       0x07,  0x01, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Hover Boots Chest":              ("Chest",       0x07,  0x07, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Early Gibdos Chest":             ("Chest",       0x07,  0x03, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Map Chest":                      ("Chest",       0x07,  0x02, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Beamos Silver Rupees Chest":     ("Chest",       0x07,  0x0F, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Falling Spikes Switch Chest":    ("Chest",       0x07,  0x04, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Falling Spikes Lower Chest":     ("Chest",       0x07,  0x05, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Falling Spikes Upper Chest":     ("Chest",       0x07,  0x06, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Invisible Spikes Chest":         ("Chest",       0x07,  0x09, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Boss Key Chest":                 ("Chest",       0x07,  0x0B, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Spike Walls Left Chest":         ("Chest",       0x07,  0x0A, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Stalfos Room Chest":             ("Chest",       0x07,  0x10, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Invisible Blades Invisible Chest": ("Chest",     0x07,  0x16, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Invisible Blades Visible Chest": ("Chest",       0x07,  0x0C, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Bomb Flower Chest":              ("Chest",       0x07,  0x0D, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Wind Hint Chest":                ("Chest",       0x07,  0x15, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ After Wind Hidden Chest":        ("Chest",       0x07,  0x14, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ After Wind Enemy Chest":         ("Chest",       0x07,  0x08, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Near Ship Invisible Chest":      ("Chest",       0x07,  0x0E, None,                     ("Shadow Temple",)),
    "Shadow Temple MQ Freestanding Key":               ("Collectable", 0x07,  0x06, None,                     ("Shadow Temple",)),

    # Bottom of the Well vanilla
    "Bottom of the Well Front Left Hidden Wall":       ("Chest",       0x08,  0x08, None,                     ("Bottom of the Well",)),
    "Bottom of the Well Front Center Bombable":        ("Chest",       0x08,  0x02, None,                     ("Bottom of the Well",)),
    "Bottom of the Well Right Bottom Hidden Wall":     ("Chest",       0x08,  0x05, None,                     ("Bottom of the Well",)),
    "Bottom of the Well Center Large Chest":           ("Chest",       0x08,  0x01, None,                     ("Bottom of the Well",)),
    "Bottom of the Well Center Small Chest":           ("Chest",       0x08,  0x0E, None,                     ("Bottom of the Well",)),
    "Bottom of the Well Back Left Bombable":           ("Chest",       0x08,  0x04, None,                     ("Bottom of the Well",)),
    "Bottom of the Well Defeat Boss":                  ("Chest",       0x08,  0x03, None,                     ("Bottom of the Well",)),
    "Bottom of the Well Invisible Chest":              ("Chest",       0x08,  0x14, None,                     ("Bottom of the Well",)),
    "Bottom of the Well Underwater Front Chest":       ("Chest",       0x08,  0x10, None,                     ("Bottom of the Well",)),
    "Bottom of the Well Underwater Left Chest":        ("Chest",       0x08,  0x09, None,                     ("Bottom of the Well",)),
    "Bottom of the Well Basement Chest":               ("Chest",       0x08,  0x07, None,                     ("Bottom of the Well",)),
    "Bottom of the Well Locked Pits":                  ("Chest",       0x08,  0x0A, None,                     ("Bottom of the Well",)),
    "Bottom of the Well Behind Right Grate":           ("Chest",       0x08,  0x0C, None,                     ("Bottom of the Well",)),
    "Bottom of the Well Freestanding Key":             ("Collectable", 0x08,  0x01, None,                     ("Bottom of the Well",)),
    # Bottom of the Well MQ
    "Bottom of the Well MQ Map Chest":                 ("Chest",       0x08,  0x03, None,                     ("Bottom of the Well",)),
    "Bottom of the Well MQ Lens Chest":                ("Chest",       0x08,  0x01, None,                     ("Bottom of the Well",)),
    "Bottom of the Well MQ Compass Chest":             ("Chest",       0x08,  0x02, None,                     ("Bottom of the Well",)),
    "Bottom of the Well MQ Dead Hand Freestanding Key":("Collectable", 0x08,  0x02, None,                     ("Bottom of the Well",)),
    "Bottom of the Well MQ East Inner Room Freestanding Key":("Collectable",0x08,0x01,None,                   ("Bottom of the Well",)),

    # Ice Cavern vanilla
    "Ice Cavern Map Chest":                            ("Chest",       0x09,  0x00, None,                     ("Ice Cavern",)),
    "Ice Cavern Compass Chest":                        ("Chest",       0x09,  0x01, None,                     ("Ice Cavern",)),
    "Ice Cavern Iron Boots Chest":                     ("Chest",       0x09,  0x02, None,                     ("Ice Cavern",)),
    "Ice Cavern Freestanding PoH":                     ("Collectable", 0x09,  0x01, None,                     ("Ice Cavern",)),
    # Ice Cavern MQ
    "Ice Cavern MQ Iron Boots Chest":                  ("Chest",       0x09,  0x02, None,                     ("Ice Cavern",)),
    "Ice Cavern MQ Compass Chest":                     ("Chest",       0x09,  0x00, None,                     ("Ice Cavern",)),
    "Ice Cavern MQ Map Chest":                         ("Chest",       0x09,  0x01, None,                     ("Ice Cavern",)),
    "Ice Cavern MQ Freestanding PoH":                  ("Collectable", 0x09,  0x01, None,                     ("Ice Cavern",)),

    # Gerudo Training Grounds vanilla
    "Gerudo Training Grounds Lobby Left Chest":        ("Chest",       0x0B,  0x13, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Lobby Right Chest":       ("Chest",       0x0B,  0x07, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Stalfos Chest":           ("Chest",       0x0B,  0x00, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Beamos Chest":            ("Chest",       0x0B,  0x01, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Hidden Ceiling Chest":    ("Chest",       0x0B,  0x0B, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Maze Path First Chest":   ("Chest",       0x0B,  0x06, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Maze Path Second Chest":  ("Chest",       0x0B,  0x0A, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Maze Path Third Chest":   ("Chest",       0x0B,  0x09, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Maze Path Final Chest":   ("Chest",       0x0B,  0x0C, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Maze Right Central Chest":("Chest",       0x0B,  0x05, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Maze Right Side Chest":   ("Chest",       0x0B,  0x08, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Underwater Silver Rupee Chest": ("Chest", 0x0B,  0x0D, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Hammer Room Clear Chest": ("Chest",       0x0B,  0x12, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Hammer Room Switch Chest":("Chest",       0x0B,  0x10, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Eye Statue Chest":        ("Chest",       0x0B,  0x03, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Near Scarecrow Chest":    ("Chest",       0x0B,  0x04, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Before Heavy Block Chest":("Chest",       0x0B,  0x11, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Heavy Block First Chest": ("Chest",       0x0B,  0x0F, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Heavy Block Second Chest":("Chest",       0x0B,  0x0E, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Heavy Block Third Chest": ("Chest",       0x0B,  0x14, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Heavy Block Fourth Chest":("Chest",       0x0B,  0x02, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds Freestanding Key":        ("Collectable", 0x0B,  0x01, None,                    ("Gerudo Training Grounds",)),
    # Gerudo Training Grounds MQ
    "Gerudo Training Grounds MQ Lobby Right Chest":    ("Chest",       0x0B,  0x07, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Lobby Left Chest":     ("Chest",       0x0B,  0x13, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ First Iron Knuckle Chest": ("Chest",   0x0B,  0x00, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Before Heavy Block Chest": ("Chest",   0x0B,  0x11, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Eye Statue Chest":     ("Chest",       0x0B,  0x03, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Flame Circle Chest":   ("Chest",       0x0B,  0x0E, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Second Iron Knuckle Chest": ("Chest",  0x0B,  0x12, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Dinolfos Chest":       ("Chest",       0x0B,  0x01, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Ice Arrows Chest":     ("Chest",       0x0B,  0x04, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Maze Right Central Chest": ("Chest",   0x0B,  0x05, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Maze Path First Chest":("Chest",       0x0B,  0x06, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Maze Right Side Chest":("Chest",       0x0B,  0x08, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Maze Path Third Chest":("Chest",       0x0B,  0x09, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Maze Path Second Chest": ("Chest",     0x0B,  0x0A, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Hidden Ceiling Chest": ("Chest",       0x0B,  0x0B, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Underwater Silver Rupee Chest":("Chest",0x0B, 0x0D, None,                    ("Gerudo Training Grounds",)),
    "Gerudo Training Grounds MQ Heavy Block Chest":    ("Chest",       0x0B,  0x02, None,                    ("Gerudo Training Grounds",)),

    # Ganon's Castle shared
    "Ganons Tower Boss Key Chest":                     ("Chest",       0x0A,  0x0B, None,                     ("Ganon's Castle",)),
    # Ganon's Castle vanilla
    "Ganons Castle Forest Trial Chest":                ("Chest",       0x0D,  0x09, None,                     ("Ganon's Castle",)),
    "Ganons Castle Water Trial Left Chest":            ("Chest",       0x0D,  0x07, None,                     ("Ganon's Castle",)),
    "Ganons Castle Water Trial Right Chest":           ("Chest",       0x0D,  0x06, None,                     ("Ganon's Castle",)),
    "Ganons Castle Shadow Trial First Chest":          ("Chest",       0x0D,  0x08, None,                     ("Ganon's Castle",)),
    "Ganons Castle Shadow Trial Second Chest":         ("Chest",       0x0D,  0x05, None,                     ("Ganon's Castle",)),
    "Ganons Castle Spirit Trial First Chest":          ("Chest",       0x0D,  0x12, None,                     ("Ganon's Castle",)),
    "Ganons Castle Spirit Trial Second Chest":         ("Chest",       0x0D,  0x14, None,                     ("Ganon's Castle",)),
    "Ganons Castle Light Trial First Left Chest":      ("Chest",       0x0D,  0x0C, None,                     ("Ganon's Castle",)),
    "Ganons Castle Light Trial Second Left Chest":     ("Chest",       0x0D,  0x0B, None,                     ("Ganon's Castle",)),
    "Ganons Castle Light Trial Third Left Chest":      ("Chest",       0x0D,  0x0D, None,                     ("Ganon's Castle",)),
    "Ganons Castle Light Trial First Right Chest":     ("Chest",       0x0D,  0x0E, None,                     ("Ganon's Castle",)),
    "Ganons Castle Light Trial Second Right Chest":    ("Chest",       0x0D,  0x0A, None,                     ("Ganon's Castle",)),
    "Ganons Castle Light Trial Third Right Chest":     ("Chest",       0x0D,  0x0F, None,                     ("Ganon's Castle",)),
    "Ganons Castle Light Trial Invisible Enemies Chest": ("Chest",     0x0D,  0x10, None,                     ("Ganon's Castle",)),
    "Ganons Castle Light Trial Lullaby Chest":         ("Chest",       0x0D,  0x11, None,                     ("Ganon's Castle",)),
    # Ganon's Castle MQ
    "Ganons Castle MQ Water Trial Chest":              ("Chest",       0x0D,  0x01, None,                     ("Ganon's Castle",)),
    "Ganons Castle MQ Forest Trial First Chest":       ("Chest",       0x0D,  0x02, None,                     ("Ganon's Castle",)),
    "Ganons Castle MQ Forest Trial Second Chest":      ("Chest",       0x0D,  0x03, None,                     ("Ganon's Castle",)),
    "Ganons Castle MQ Light Trial Lullaby Chest":      ("Chest",       0x0D,  0x04, None,                     ("Ganon's Castle",)),
    "Ganons Castle MQ Shadow Trial First Chest":       ("Chest",       0x0D,  0x00, None,                     ("Ganon's Castle",)),
    "Ganons Castle MQ Shadow Trial Second Chest":      ("Chest",       0x0D,  0x05, None,                     ("Ganon's Castle",)),
    "Ganons Castle MQ Spirit Trial Golden Gauntlets Chest": ("Chest",  0x0D,  0x06, None,                     ("Ganon's Castle",)),
    "Ganons Castle MQ Spirit Trial Sun Back Right Chest": ("Chest",    0x0D,  0x07, None,                     ("Ganon's Castle",)),
    "Ganons Castle MQ Spirit Trial Sun Back Left Chest": ("Chest",     0x0D,  0x08, None,                     ("Ganon's Castle",)),
    "Ganons Castle MQ Spirit Trial Sun Front Left Chest": ("Chest",    0x0D,  0x09, None,                     ("Ganon's Castle",)),
    "Ganons Castle MQ Spirit Trial First Chest":       ("Chest",       0x0D,  0x0A, None,                     ("Ganon's Castle",)),
    "Ganons Castle MQ Spirit Trial Second Chest":      ("Chest",       0x0D,  0x14, None,                     ("Ganon's Castle",)),
    "Ganons Castle MQ Forest Trial Freestanding Key":  ("Collectable", 0x0D,  0x01, None,                     ("Ganon's Castle",)),

    "Links Pocket":                                    ("Boss",        None,  None, None,                     None),
    "Queen Gohma":                                     ("Boss",        None,  0x6C, (0x0CA315F, 0x2079571),   None),
    "King Dodongo":                                    ("Boss",        None,  0x6D, (0x0CA30DF, 0x2223309),   None),
    "Barinade":                                        ("Boss",        None,  0x6E, (0x0CA36EB, 0x2113C19),   None),
    "Phantom Ganon":                                   ("Boss",        None,  0x66, (0x0CA3D07, 0x0D4ED79),   None),
    "Volvagia":                                        ("Boss",        None,  0x67, (0x0CA3D93, 0x0D10135),   None),
    "Morpha":                                          ("Boss",        None,  0x68, (0x0CA3E1F, 0x0D5A3A9),   None),
    "Twinrova":                                        ("Boss",        None,  0x69, (0x0CA3EB3, 0x0D39FF1),   None),
    "Bongo Bongo":                                     ("Boss",        None,  0x6A, (0x0CA3F43, 0x0D13E19),   None),
    "Ganon":                                           ("Event",       None,  None, None,                     None),

    "Queen Gohma Heart":                               ("BossHeart",   0x11,  0x4F, None,                     ("Deku Tree",)),
    "King Dodongo Heart":                              ("BossHeart",   0x12,  0x4F, None,                     ("Dodongo's Cavern",)),
    "Barinade Heart":                                  ("BossHeart",   0x13,  0x4F, None,                     ("Jabu Jabu's Belly",)),
    "Phantom Ganon Heart":                             ("BossHeart",   0x14,  0x4F, None,                     ("Forest Temple",)),
    "Volvagia Heart":                                  ("BossHeart",   0x15,  0x4F, None,                     ("Fire Temple",)),
    "Morpha Heart":                                    ("BossHeart",   0x16,  0x4F, None,                     ("Water Temple",)),
    "Twinrova Heart":                                  ("BossHeart",   0x17,  0x4F, None,                     ("Spirit Temple",)),
    "Bongo Bongo Heart":                               ("BossHeart",   0x18,  0x4F, None,                     ("Shadow Temple",)),

    # note that the scene for skulltulas is not the actual scene the token appears in
    # rather, it is the index of the grouping used when storing skulltula collection
    # for example, zora river, zora's domain, and zora fountain are all a single 'scene' for skulltulas
    "GS Deku Tree Basement Back Room":                 ("GS Token",    0x00,  0x01, None,                     ("Deku Tree", "Skulltulas",)),
    "GS Deku Tree Basement Gate":                      ("GS Token",    0x00,  0x02, None,                     ("Deku Tree", "Skulltulas",)),
    "GS Deku Tree Basement Vines":                     ("GS Token",    0x00,  0x04, None,                     ("Deku Tree", "Skulltulas",)),
    "GS Deku Tree Compass Room":                       ("GS Token",    0x00,  0x08, None,                     ("Deku Tree", "Skulltulas",)),
    "GS Deku Tree MQ Lobby":                           ("GS Token",    0x00,  0x02, None,                     ("Deku Tree", "Skulltulas",)),
    "GS Deku Tree MQ Compass Room":                    ("GS Token",    0x00,  0x08, None,                     ("Deku Tree", "Skulltulas",)),
    "GS Deku Tree MQ Basement Ceiling":                ("GS Token",    0x00,  0x04, None,                     ("Deku Tree", "Skulltulas",)),
    "GS Deku Tree MQ Basement Back Room":              ("GS Token",    0x00,  0x01, None,                     ("Deku Tree", "Skulltulas",)),
    "GS Dodongo's Cavern Vines Above Stairs":          ("GS Token",    0x01,  0x01, None,                     ("Dodongo's Cavern", "Skulltulas",)),
    "GS Dodongo's Cavern Scarecrow":                   ("GS Token",    0x01,  0x02, None,                     ("Dodongo's Cavern", "Skulltulas",)),
    "GS Dodongo's Cavern Alcove Above Stairs":         ("GS Token",    0x01,  0x04, None,                     ("Dodongo's Cavern", "Skulltulas",)),
    "GS Dodongo's Cavern Back Room":                   ("GS Token",    0x01,  0x08, None,                     ("Dodongo's Cavern", "Skulltulas",)),
    "GS Dodongo's Cavern East Side Room":              ("GS Token",    0x01,  0x10, None,                     ("Dodongo's Cavern", "Skulltulas",)),
    "GS Dodongo's Cavern MQ Scrub Room":               ("GS Token",    0x01,  0x02, None,                     ("Dodongo's Cavern", "Skulltulas",)),
    "GS Dodongo's Cavern MQ Song of Time Block Room":  ("GS Token",    0x01,  0x08, None,                     ("Dodongo's Cavern", "Skulltulas",)),
    "GS Dodongo's Cavern MQ Lizalfos Room":            ("GS Token",    0x01,  0x04, None,                     ("Dodongo's Cavern", "Skulltulas",)),
    "GS Dodongo's Cavern MQ Larva Room":               ("GS Token",    0x01,  0x10, None,                     ("Dodongo's Cavern", "Skulltulas",)),
    "GS Dodongo's Cavern MQ Back Area":                ("GS Token",    0x01,  0x01, None,                     ("Dodongo's Cavern", "Skulltulas",)),
    "GS Jabu Jabu Lobby Basement Lower":               ("GS Token",    0x02,  0x01, None,                     ("Jabu Jabu's Belly", "Skulltulas",)),
    "GS Jabu Jabu Lobby Basement Upper":               ("GS Token",    0x02,  0x02, None,                     ("Jabu Jabu's Belly", "Skulltulas",)),
    "GS Jabu Jabu Near Boss":                          ("GS Token",    0x02,  0x04, None,                     ("Jabu Jabu's Belly", "Skulltulas",)),
    "GS Jabu Jabu Water Switch Room":                  ("GS Token",    0x02,  0x08, None,                     ("Jabu Jabu's Belly", "Skulltulas",)),
    "GS Jabu Jabu MQ Tailpasaran Room":                ("GS Token",    0x02,  0x04, None,                     ("Jabu Jabu's Belly", "Skulltulas",)),
    "GS Jabu Jabu MQ Invisible Enemies Room":          ("GS Token",    0x02,  0x08, None,                     ("Jabu Jabu's Belly", "Skulltulas",)),
    "GS Jabu Jabu MQ Boomerang Room":                  ("GS Token",    0x02,  0x01, None,                     ("Jabu Jabu's Belly", "Skulltulas",)),
    "GS Jabu Jabu MQ Near Boss":                       ("GS Token",    0x02,  0x02, None,                     ("Jabu Jabu's Belly", "Skulltulas",)),
    "GS Forest Temple Outdoor East":                   ("GS Token",    0x03,  0x01, None,                     ("Forest Temple", "Skulltulas",)),
    "GS Forest Temple First Room":                     ("GS Token",    0x03,  0x02, None,                     ("Forest Temple", "Skulltulas",)),
    "GS Forest Temple Outdoor West":                   ("GS Token",    0x03,  0x04, None,                     ("Forest Temple", "Skulltulas",)),
    "GS Forest Temple Lobby":                          ("GS Token",    0x03,  0x08, None,                     ("Forest Temple", "Skulltulas",)),
    "GS Forest Temple Basement":                       ("GS Token",    0x03,  0x10, None,                     ("Forest Temple", "Skulltulas",)),
    "GS Forest Temple MQ First Hallway":               ("GS Token",    0x03,  0x02, None,                     ("Forest Temple", "Skulltulas",)),
    "GS Forest Temple MQ Block Push Room":             ("GS Token",    0x03,  0x10, None,                     ("Forest Temple", "Skulltulas",)),
    "GS Forest Temple MQ Outdoor East":                ("GS Token",    0x03,  0x01, None,                     ("Forest Temple", "Skulltulas",)),
    "GS Forest Temple MQ Outdoor West":                ("GS Token",    0x03,  0x04, None,                     ("Forest Temple", "Skulltulas",)),
    "GS Forest Temple MQ Well":                        ("GS Token",    0x03,  0x08, None,                     ("Forest Temple", "Skulltulas",)),
    "GS Fire Temple Song of Time Room":                ("GS Token",    0x04,  0x01, None,                     ("Fire Temple", "Skulltulas",)),
    "GS Fire Temple Basement":                         ("GS Token",    0x04,  0x02, None,                     ("Fire Temple", "Skulltulas",)),
    "GS Fire Temple Unmarked Bomb Wall":               ("GS Token",    0x04,  0x04, None,                     ("Fire Temple", "Skulltulas",)),
    "GS Fire Temple East Tower Top":                   ("GS Token",    0x04,  0x08, None,                     ("Fire Temple", "Skulltulas",)),
    "GS Fire Temple East Tower Climb":                 ("GS Token",    0x04,  0x10, None,                     ("Fire Temple", "Skulltulas",)),
    "GS Fire Temple MQ Above Fire Wall Maze":          ("GS Token",    0x04,  0x02, None,                     ("Fire Temple", "Skulltulas",)),
    "GS Fire Temple MQ Fire Wall Maze Center":         ("GS Token",    0x04,  0x08, None,                     ("Fire Temple", "Skulltulas",)),
    "GS Fire Temple MQ Big Lava Room":                 ("GS Token",    0x04,  0x01, None,                     ("Fire Temple", "Skulltulas",)),
    "GS Fire Temple MQ Fire Wall Maze Side Room":      ("GS Token",    0x04,  0x10, None,                     ("Fire Temple", "Skulltulas",)),
    "GS Fire Temple MQ East Tower Top":                ("GS Token",    0x04,  0x04, None,                     ("Fire Temple", "Skulltulas",)),
    "GS Water Temple South Basement":                  ("GS Token",    0x05,  0x01, None,                     ("Water Temple", "Skulltulas",)),
    "GS Water Temple Falling Platform Room":           ("GS Token",    0x05,  0x02, None,                     ("Water Temple", "Skulltulas",)),
    "GS Water Temple Central Room":                    ("GS Token",    0x05,  0x04, None,                     ("Water Temple", "Skulltulas",)),
    "GS Water Temple Near Boss Key Chest":             ("GS Token",    0x05,  0x08, None,                     ("Water Temple", "Skulltulas",)),
    "GS Water Temple Serpent River":                   ("GS Token",    0x05,  0x10, None,                     ("Water Temple", "Skulltulas",)),
    "GS Water Temple MQ Before Upper Water Switch":    ("GS Token",    0x05,  0x04, None,                     ("Water Temple", "Skulltulas",)),
    "GS Water Temple MQ North Basement":               ("GS Token",    0x05,  0x08, None,                     ("Water Temple", "Skulltulas",)),
    "GS Water Temple MQ Lizalfos Hallway":             ("GS Token",    0x05,  0x01, None,                     ("Water Temple", "Skulltulas",)),
    "GS Water Temple MQ Serpent River":                ("GS Token",    0x05,  0x02, None,                     ("Water Temple", "Skulltulas",)),
    "GS Water Temple MQ South Basement":               ("GS Token",    0x05,  0x10, None,                     ("Water Temple", "Skulltulas",)),
    "GS Spirit Temple Hall to West Iron Knuckle":      ("GS Token",    0x06,  0x01, None,                     ("Spirit Temple", "Skulltulas",)),
    "GS Spirit Temple Boulder Room":                   ("GS Token",    0x06,  0x02, None,                     ("Spirit Temple", "Skulltulas",)),
    "GS Spirit Temple Lobby":                          ("GS Token",    0x06,  0x04, None,                     ("Spirit Temple", "Skulltulas",)),
    "GS Spirit Temple Bomb for Light Room":            ("GS Token",    0x06,  0x08, None,                     ("Spirit Temple", "Skulltulas",)),
    "GS Spirit Temple Metal Fence":                    ("GS Token",    0x06,  0x10, None,                     ("Spirit Temple", "Skulltulas",)),
    "GS Spirit Temple MQ Lower Adult Right":           ("GS Token",    0x06,  0x08, None,                     ("Spirit Temple", "Skulltulas",)),
    "GS Spirit Temple MQ Lower Adult Left":            ("GS Token",    0x06,  0x02, None,                     ("Spirit Temple", "Skulltulas",)),
    "GS Spirit Temple MQ Iron Knuckle West":           ("GS Token",    0x06,  0x04, None,                     ("Spirit Temple", "Skulltulas",)),
    "GS Spirit Temple MQ Iron Knuckle North":          ("GS Token",    0x06,  0x10, None,                     ("Spirit Temple", "Skulltulas",)),
    "GS Spirit Temple MQ Sun Block Room":              ("GS Token",    0x06,  0x01, None,                     ("Spirit Temple", "Skulltulas",)),
    "GS Shadow Temple Single Giant Pot":               ("GS Token",    0x07,  0x01, None,                     ("Shadow Temple", "Skulltulas",)),
    "GS Shadow Temple Crusher Room":                   ("GS Token",    0x07,  0x02, None,                     ("Shadow Temple", "Skulltulas",)),
    "GS Shadow Temple Triple Giant Pot":               ("GS Token",    0x07,  0x04, None,                     ("Shadow Temple", "Skulltulas",)),
    "GS Shadow Temple Like Like Room":                 ("GS Token",    0x07,  0x08, None,                     ("Shadow Temple", "Skulltulas",)),
    "GS Shadow Temple Near Ship":                      ("GS Token",    0x07,  0x10, None,                     ("Shadow Temple", "Skulltulas",)),
    "GS Shadow Temple MQ Crusher Room":                ("GS Token",    0x07,  0x02, None,                     ("Shadow Temple", "Skulltulas",)),
    "GS Shadow Temple MQ Wind Hint Room":              ("GS Token",    0x07,  0x01, None,                     ("Shadow Temple", "Skulltulas",)),
    "GS Shadow Temple MQ After Wind":                  ("GS Token",    0x07,  0x08, None,                     ("Shadow Temple", "Skulltulas",)),
    "GS Shadow Temple MQ After Ship":                  ("GS Token",    0x07,  0x10, None,                     ("Shadow Temple", "Skulltulas",)),
    "GS Shadow Temple MQ Near Boss":                   ("GS Token",    0x07,  0x04, None,                     ("Shadow Temple", "Skulltulas",)),
    "GS Well Like Like Cage":                          ("GS Token",    0x08,  0x01, None,                     ("Bottom of the Well", "Skulltulas",)),
    "GS Well East Inner Room":                         ("GS Token",    0x08,  0x02, None,                     ("Bottom of the Well", "Skulltulas",)),
    "GS Well West Inner Room":                         ("GS Token",    0x08,  0x04, None,                     ("Bottom of the Well", "Skulltulas",)),
    "GS Well MQ Basement":                             ("GS Token",    0x08,  0x01, None,                     ("Bottom of the Well", "Skulltulas",)),
    "GS Well MQ Coffin Room":                          ("GS Token",    0x08,  0x04, None,                     ("Bottom of the Well", "Skulltulas",)),
    "GS Well MQ West Inner Room":                      ("GS Token",    0x08,  0x02, None,                     ("Bottom of the Well", "Skulltulas",)),
    "GS Ice Cavern Push Block Room":                   ("GS Token",    0x09,  0x01, None,                     ("Ice Cavern", "Skulltulas",)),
    "GS Ice Cavern Spinning Scythe Room":              ("GS Token",    0x09,  0x02, None,                     ("Ice Cavern", "Skulltulas",)),
    "GS Ice Cavern Heart Piece Room":                  ("GS Token",    0x09,  0x04, None,                     ("Ice Cavern", "Skulltulas",)),
    "GS Ice Cavern MQ Scarecrow":                      ("GS Token",    0x09,  0x01, None,                     ("Ice Cavern", "Skulltulas",)),
    "GS Ice Cavern MQ Ice Block":                      ("GS Token",    0x09,  0x04, None,                     ("Ice Cavern", "Skulltulas",)),
    "GS Ice Cavern MQ Red Ice":                        ("GS Token",    0x09,  0x02, None,                     ("Ice Cavern", "Skulltulas",)),
    "GS Hyrule Field Near Gerudo Valley":              ("GS Token",    0x0A,  0x01, None,                     ("Hyrule Field", "Skulltulas", "Grottos")),
    "GS Hyrule Field near Kakariko":                   ("GS Token",    0x0A,  0x02, None,                     ("Hyrule Field", "Skulltulas", "Grottos")),
    "GS Lon Lon Ranch Back Wall":                      ("GS Token",    0x0B,  0x01, None,                     ("Lon Lon Ranch", "Skulltulas",)),
    "GS Lon Lon Ranch Rain Shed":                      ("GS Token",    0x0B,  0x02, None,                     ("Lon Lon Ranch", "Skulltulas",)),
    "GS Lon Lon Ranch House Window":                   ("GS Token",    0x0B,  0x04, None,                     ("Lon Lon Ranch", "Skulltulas",)),
    "GS Lon Lon Ranch Tree":                           ("GS Token",    0x0B,  0x08, None,                     ("Lon Lon Ranch", "Skulltulas",)),
    "GS Kokiri Bean Patch":                            ("GS Token",    0x0C,  0x01, None,                     ("Kokiri Forest", "Skulltulas",)),
    "GS Kokiri Know It All House":                     ("GS Token",    0x0C,  0x02, None,                     ("Kokiri Forest", "Skulltulas",)),
    "GS Kokiri House of Twins":                        ("GS Token",    0x0C,  0x04, None,                     ("Kokiri Forest", "Skulltulas",)),
    "GS Lost Woods Bean Patch Near Bridge":            ("GS Token",    0x0D,  0x01, None,                     ("the Lost Woods", "Skulltulas",)),
    "GS Lost Woods Bean Patch Near Stage":             ("GS Token",    0x0D,  0x02, None,                     ("the Lost Woods", "Skulltulas",)),
    "GS Lost Woods Above Stage":                       ("GS Token",    0x0D,  0x04, None,                     ("the Lost Woods", "Skulltulas",)),
    "GS Sacred Forest Meadow":                         ("GS Token",    0x0D,  0x08, None,                     ("Sacred Forest Meadow", "Skulltulas",)),
    "GS Outside Ganon's Castle":                       ("GS Token",    0x0E,  0x01, None,                     ("outside Ganon's Castle", "Skulltulas",)),
    "GS Hyrule Castle Grotto":                         ("GS Token",    0x0E,  0x02, None,                     ("Hyrule Castle", "Skulltulas", "Grottos")),
    "GS Hyrule Castle Tree":                           ("GS Token",    0x0E,  0x04, None,                     ("Hyrule Castle", "Skulltulas",)),
    "GS Castle Market Guard House":                    ("GS Token",    0x0E,  0x08, None,                     ("the Market", "Skulltulas",)),
    "GS Mountain Crater Bean Patch":                   ("GS Token",    0x0F,  0x01, None,                     ("Death Mountain Crater", "Skulltulas",)),
    "GS Mountain Trail Bean Patch":                    ("GS Token",    0x0F,  0x02, None,                     ("Death Mountain Trail", "Skulltulas",)),
    "GS Mountain Trail Bomb Alcove":                   ("GS Token",    0x0F,  0x04, None,                     ("Death Mountain Trail", "Skulltulas",)),
    "GS Mountain Trail Above Dodongo's Cavern":        ("GS Token",    0x0F,  0x08, None,                     ("Death Mountain Trail", "Skulltulas",)),
    "GS Mountain Trail Path to Crater":                ("GS Token",    0x0F,  0x10, None,                     ("Death Mountain Trail", "Skulltulas",)),
    "GS Goron City Center Platform":                   ("GS Token",    0x0F,  0x20, None,                     ("Goron City", "Skulltulas",)),
    "GS Goron City Boulder Maze":                      ("GS Token",    0x0F,  0x40, None,                     ("Goron City", "Skulltulas",)),
    "GS Death Mountain Crater Crate":                  ("GS Token",    0x0F,  0x80, None,                     ("Death Mountain Crater", "Skulltulas",)),
    "GS Kakariko House Under Construction":            ("GS Token",    0x10,  0x08, None,                     ("Kakariko Village", "Skulltulas",)),
    "GS Kakariko Skulltula House":                     ("GS Token",    0x10,  0x10, None,                     ("Kakariko Village", "Skulltulas",)),
    "GS Kakariko Guard's House":                       ("GS Token",    0x10,  0x02, None,                     ("Kakariko Village", "Skulltulas",)),
    "GS Kakariko Tree":                                ("GS Token",    0x10,  0x20, None,                     ("Kakariko Village", "Skulltulas",)),
    "GS Kakariko Watchtower":                          ("GS Token",    0x10,  0x04, None,                     ("Kakariko Village", "Skulltulas",)),
    "GS Kakariko Above Impa's House":                  ("GS Token",    0x10,  0x40, None,                     ("Kakariko Village", "Skulltulas",)),
    "GS Graveyard Wall":                               ("GS Token",    0x10,  0x80, None,                     ("the Graveyard", "Skulltulas",)),
    "GS Graveyard Bean Patch":                         ("GS Token",    0x10,  0x01, None,                     ("the Graveyard", "Skulltulas",)),
    "GS Zora River Ladder":                            ("GS Token",    0x11,  0x01, None,                     ("Zora's River", "Skulltulas",)),
    "GS Zora River Tree":                              ("GS Token",    0x11,  0x02, None,                     ("Zora's River", "Skulltulas",)),
    "GS Zora's Fountain Above the Log":                ("GS Token",    0x11,  0x04, None,                     ("Zora's Fountain", "Skulltulas",)),
    "GS Zora River Above Bridge":                      ("GS Token",    0x11,  0x08, None,                     ("Zora's River", "Skulltulas",)),
    "GS Zora River Near Raised Grottos":               ("GS Token",    0x11,  0x10, None,                     ("Zora's River", "Skulltulas",)),
    "GS Zora's Fountain Hidden Cave":                  ("GS Token",    0x11,  0x20, None,                     ("Zora's Fountain", "Skulltulas",)),
    "GS Zora's Domain Frozen Waterfall":               ("GS Token",    0x11,  0x40, None,                     ("Zora's Domain", "Skulltulas",)),
    "GS Zora's Fountain Tree":                         ("GS Token",    0x11,  0x80, None,                     ("Zora's Fountain", "Skulltulas",)),
    "GS Lake Hylia Bean Patch":                        ("GS Token",    0x12,  0x01, None,                     ("Lake Hylia", "Skulltulas",)),
    "GS Lake Hylia Small Island":                      ("GS Token",    0x12,  0x02, None,                     ("Lake Hylia", "Skulltulas",)),
    "GS Lake Hylia Lab Wall":                          ("GS Token",    0x12,  0x04, None,                     ("Lake Hylia", "Skulltulas",)),
    "GS Lab Underwater Crate":                         ("GS Token",    0x12,  0x08, None,                     ("Lake Hylia", "Skulltulas",)),
    "GS Lake Hylia Giant Tree":                        ("GS Token",    0x12,  0x10, None,                     ("Lake Hylia", "Skulltulas",)),
    "GS Gerudo Valley Bean Patch":                     ("GS Token",    0x13,  0x01, None,                     ("Gerudo Valley", "Skulltulas",)),
    "GS Gerudo Valley Small Bridge":                   ("GS Token",    0x13,  0x02, None,                     ("Gerudo Valley", "Skulltulas",)),
    "GS Gerudo Valley Pillar":                         ("GS Token",    0x13,  0x04, None,                     ("Gerudo Valley", "Skulltulas",)),
    "GS Gerudo Valley Behind Tent":                    ("GS Token",    0x13,  0x08, None,                     ("Gerudo Valley", "Skulltulas",)),
    "GS Gerudo Fortress Archery Range":                ("GS Token",    0x14,  0x01, None,                     ("Gerudo's Fortress", "Skulltulas",)),
    "GS Gerudo Fortress Top Floor":                    ("GS Token",    0x14,  0x02, None,                     ("Gerudo's Fortress", "Skulltulas",)),
    "GS Desert Colossus Bean Patch":                   ("GS Token",    0x15,  0x01, None,                     ("Desert Colossus", "Skulltulas",)),
    "GS Wasteland Ruins":                              ("GS Token",    0x15,  0x02, None,                     ("Haunted Wasteland", "Skulltulas",)),
    "GS Desert Colossus Hill":                         ("GS Token",    0x15,  0x04, None,                     ("Desert Colossus", "Skulltulas",)),
    "GS Desert Colossus Tree":                         ("GS Token",    0x15,  0x08, None,                     ("Desert Colossus", "Skulltulas",)),

    "Kokiri Shop Item 1":                              ("Shop",        0x2D,  0x30, (shop_address(0, 0), None), ("Kokiri Forest", "Forest", "Shops")),
    "Kokiri Shop Item 2":                              ("Shop",        0x2D,  0x31, (shop_address(0, 1), None), ("Kokiri Forest", "Forest", "Shops")),
    "Kokiri Shop Item 3":                              ("Shop",        0x2D,  0x32, (shop_address(0, 2), None), ("Kokiri Forest", "Forest", "Shops")),
    "Kokiri Shop Item 4":                              ("Shop",        0x2D,  0x33, (shop_address(0, 3), None), ("Kokiri Forest", "Forest", "Shops")),
    "Kokiri Shop Item 5":                              ("Shop",        0x2D,  0x34, (shop_address(0, 4), None), ("Kokiri Forest", "Forest", "Shops")),
    "Kokiri Shop Item 6":                              ("Shop",        0x2D,  0x35, (shop_address(0, 5), None), ("Kokiri Forest", "Forest", "Shops")),
    "Kokiri Shop Item 7":                              ("Shop",        0x2D,  0x36, (shop_address(0, 6), None), ("Kokiri Forest", "Forest", "Shops")),
    "Kokiri Shop Item 8":                              ("Shop",        0x2D,  0x37, (shop_address(0, 7), None), ("Kokiri Forest", "Forest", "Shops")),
    "Kakariko Potion Shop Item 1":                     ("Shop",        0x30,  0x30, (shop_address(1, 0), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Kakariko Potion Shop Item 2":                     ("Shop",        0x30,  0x31, (shop_address(1, 1), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Kakariko Potion Shop Item 3":                     ("Shop",        0x30,  0x32, (shop_address(1, 2), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Kakariko Potion Shop Item 4":                     ("Shop",        0x30,  0x33, (shop_address(1, 3), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Kakariko Potion Shop Item 5":                     ("Shop",        0x30,  0x34, (shop_address(1, 4), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Kakariko Potion Shop Item 6":                     ("Shop",        0x30,  0x35, (shop_address(1, 5), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Kakariko Potion Shop Item 7":                     ("Shop",        0x30,  0x36, (shop_address(1, 6), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Kakariko Potion Shop Item 8":                     ("Shop",        0x30,  0x37, (shop_address(1, 7), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Bombchu Shop Item 1":                             ("Shop",        0x32,  0x30, (shop_address(2, 0), None), ("the Market", "Castle Town", "Shops")),
    "Bombchu Shop Item 2":                             ("Shop",        0x32,  0x31, (shop_address(2, 1), None), ("the Market", "Castle Town", "Shops")),
    "Bombchu Shop Item 3":                             ("Shop",        0x32,  0x32, (shop_address(2, 2), None), ("the Market", "Castle Town", "Shops")),
    "Bombchu Shop Item 4":                             ("Shop",        0x32,  0x33, (shop_address(2, 3), None), ("the Market", "Castle Town", "Shops")),
    "Bombchu Shop Item 5":                             ("Shop",        0x32,  0x34, (shop_address(2, 4), None), ("the Market", "Castle Town", "Shops")),
    "Bombchu Shop Item 6":                             ("Shop",        0x32,  0x35, (shop_address(2, 5), None), ("the Market", "Castle Town", "Shops")),
    "Bombchu Shop Item 7":                             ("Shop",        0x32,  0x36, (shop_address(2, 6), None), ("the Market", "Castle Town", "Shops")),
    "Bombchu Shop Item 8":                             ("Shop",        0x32,  0x37, (shop_address(2, 7), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Potion Shop Item 1":                  ("Shop",        0x31,  0x30, (shop_address(3, 0), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Potion Shop Item 2":                  ("Shop",        0x31,  0x31, (shop_address(3, 1), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Potion Shop Item 3":                  ("Shop",        0x31,  0x32, (shop_address(3, 2), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Potion Shop Item 4":                  ("Shop",        0x31,  0x33, (shop_address(3, 3), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Potion Shop Item 5":                  ("Shop",        0x31,  0x34, (shop_address(3, 4), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Potion Shop Item 6":                  ("Shop",        0x31,  0x35, (shop_address(3, 5), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Potion Shop Item 7":                  ("Shop",        0x31,  0x36, (shop_address(3, 6), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Potion Shop Item 8":                  ("Shop",        0x31,  0x37, (shop_address(3, 7), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Bazaar Item 1":                       ("Shop",        0x2C,  0x30, (shop_address(4, 0), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Bazaar Item 2":                       ("Shop",        0x2C,  0x31, (shop_address(4, 1), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Bazaar Item 3":                       ("Shop",        0x2C,  0x32, (shop_address(4, 2), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Bazaar Item 4":                       ("Shop",        0x2C,  0x33, (shop_address(4, 3), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Bazaar Item 5":                       ("Shop",        0x2C,  0x34, (shop_address(4, 4), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Bazaar Item 6":                       ("Shop",        0x2C,  0x35, (shop_address(4, 5), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Bazaar Item 7":                       ("Shop",        0x2C,  0x36, (shop_address(4, 6), None), ("the Market", "Castle Town", "Shops")),
    "Castle Town Bazaar Item 8":                       ("Shop",        0x2C,  0x37, (shop_address(4, 7), None), ("the Market", "Castle Town", "Shops")),
    "Kakariko Bazaar Item 1":                          ("Shop",        0x2C,  0x38, (shop_address(5, 0), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Kakariko Bazaar Item 2":                          ("Shop",        0x2C,  0x39, (shop_address(5, 1), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Kakariko Bazaar Item 3":                          ("Shop",        0x2C,  0x3A, (shop_address(5, 2), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Kakariko Bazaar Item 4":                          ("Shop",        0x2C,  0x3B, (shop_address(5, 3), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Kakariko Bazaar Item 5":                          ("Shop",        0x2C,  0x3D, (shop_address(5, 4), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Kakariko Bazaar Item 6":                          ("Shop",        0x2C,  0x3E, (shop_address(5, 5), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Kakariko Bazaar Item 7":                          ("Shop",        0x2C,  0x3F, (shop_address(5, 6), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Kakariko Bazaar Item 8":                          ("Shop",        0x2C,  0x40, (shop_address(5, 7), None), ("Kakariko Village", "Kakariko", "Shops")),
    "Zora Shop Item 1":                                ("Shop",        0x2F,  0x30, (shop_address(7, 0), None), ("Zora's Domain", "Shops",)),
    "Zora Shop Item 2":                                ("Shop",        0x2F,  0x31, (shop_address(7, 1), None), ("Zora's Domain", "Shops",)),
    "Zora Shop Item 3":                                ("Shop",        0x2F,  0x32, (shop_address(7, 2), None), ("Zora's Domain", "Shops",)),
    "Zora Shop Item 4":                                ("Shop",        0x2F,  0x33, (shop_address(7, 3), None), ("Zora's Domain", "Shops",)),
    "Zora Shop Item 5":                                ("Shop",        0x2F,  0x34, (shop_address(7, 4), None), ("Zora's Domain", "Shops",)),
    "Zora Shop Item 6":                                ("Shop",        0x2F,  0x35, (shop_address(7, 5), None), ("Zora's Domain", "Shops",)),
    "Zora Shop Item 7":                                ("Shop",        0x2F,  0x36, (shop_address(7, 6), None), ("Zora's Domain", "Shops",)),
    "Zora Shop Item 8":                                ("Shop",        0x2F,  0x37, (shop_address(7, 7), None), ("Zora's Domain", "Shops",)),
    "Goron Shop Item 1":                               ("Shop",        0x2E,  0x30, (shop_address(8, 0), None), ("Goron City", "Shops",)),
    "Goron Shop Item 2":                               ("Shop",        0x2E,  0x31, (shop_address(8, 1), None), ("Goron City", "Shops",)),
    "Goron Shop Item 3":                               ("Shop",        0x2E,  0x32, (shop_address(8, 2), None), ("Goron City", "Shops",)),
    "Goron Shop Item 4":                               ("Shop",        0x2E,  0x33, (shop_address(8, 3), None), ("Goron City", "Shops",)),
    "Goron Shop Item 5":                               ("Shop",        0x2E,  0x34, (shop_address(8, 4), None), ("Goron City", "Shops",)),
    "Goron Shop Item 6":                               ("Shop",        0x2E,  0x35, (shop_address(8, 5), None), ("Goron City", "Shops",)),
    "Goron Shop Item 7":                               ("Shop",        0x2E,  0x36, (shop_address(8, 6), None), ("Goron City", "Shops",)),
    "Goron Shop Item 8":                               ("Shop",        0x2E,  0x37, (shop_address(8, 7), None), ("Goron City", "Shops",)),

    # NPC Scrubs are on the overworld, while GrottoNPC is a special handler for Grottos
    # Grottos scrubs are the same scene and actor, so we use a unique grotto ID for the scene
    "DC Deku Scrub Deku Nuts":                         ("NPC",         0x01,  0x30, None,                     ("Dodongo's Cavern", "Deku Scrub",)),
    "DC Deku Scrub Deku Sticks":                       ("NPC",         0x01,  0x31, None,                     ("Dodongo's Cavern", "Deku Scrub",)),
    "DC Deku Scrub Deku Seeds":                        ("NPC",         0x01,  0x33, None,                     ("Dodongo's Cavern", "Deku Scrub",)),
    "DC Deku Scrub Deku Shield":                       ("NPC",         0x01,  0x34, None,                     ("Dodongo's Cavern", "Deku Scrub",)),
    "Jabu Deku Scrub Deku Nuts":                       ("NPC",         0x02,  0x30, None,                     ("Jabu Jabu's Belly", "Deku Scrub",)),
    "GC Deku Scrub Bombs":                             ("NPC",         0x0D,  0x37, None,                     ("Ganon's Castle", "Deku Scrub",)),
    "GC Deku Scrub Arrows":                            ("NPC",         0x0D,  0x33, None,                     ("Ganon's Castle", "Deku Scrub",)),
    "GC Deku Scrub Red Potion":                        ("NPC",         0x0D,  0x39, None,                     ("Ganon's Castle", "Deku Scrub",)),
    "GC Deku Scrub Green Potion":                      ("NPC",         0x0D,  0x3A, None,                     ("Ganon's Castle", "Deku Scrub",)),
    "DT MQ Deku Scrub Deku Shield":                    ("NPC",         0x00,  0x34, None,                     ("Deku Tree", "Deku Scrub",)),
    "DC MQ Deku Scrub Deku Sticks":                    ("NPC",         0x01,  0x31, None,                     ("Dodongo's Cavern", "Deku Scrub",)),
    "DC MQ Deku Scrub Deku Seeds":                     ("NPC",         0x01,  0x33, None,                     ("Dodongo's Cavern", "Deku Scrub",)),
    "DC MQ Deku Scrub Deku Shield":                    ("NPC",         0x01,  0x34, None,                     ("Dodongo's Cavern", "Deku Scrub",)),
    "DC MQ Deku Scrub Red Potion":                     ("NPC",         0x01,  0x39, None,                     ("Dodongo's Cavern", "Deku Scrub",)),
    "GC MQ Deku Scrub Deku Nuts":                      ("NPC",         0x0D,  0x30, None,                     ("Ganon's Castle", "Deku Scrub",)),
    "GC MQ Deku Scrub Bombs":                          ("NPC",         0x0D,  0x37, None,                     ("Ganon's Castle", "Deku Scrub",)),
    "GC MQ Deku Scrub Arrows":                         ("NPC",         0x0D,  0x33, None,                     ("Ganon's Castle", "Deku Scrub",)),
    "GC MQ Deku Scrub Red Potion":                     ("NPC",         0x0D,  0x39, None,                     ("Ganon's Castle", "Deku Scrub",)),
    "GC MQ Deku Scrub Green Potion":                   ("NPC",         0x0D,  0x3A, None,                     ("Ganon's Castle", "Deku Scrub",)),
    "HF Grotto Deku Scrub Piece of Heart":             ("GrottoNPC",   0xE6,  0x3E, None,                     ("Hyrule Field", "Deku Scrub", "Deku Scrub Upgrades", "Grottos")),
    "ZR Grotto Deku Scrub Red Potion":                 ("GrottoNPC",   0xEB,  0x39, None,                     ("Zora's River", "Deku Scrub", "Grottos")),
    "ZR Grotto Deku Scrub Green Potion":               ("GrottoNPC",   0xEB,  0x3A, None,                     ("Zora's River", "Deku Scrub", "Grottos")),
    "SFM Grotto Deku Scrub Red Potion":                ("GrottoNPC",   0xEE,  0x39, None,                     ("Sacred Forest Meadow", "Forest", "Deku Scrub", "Grottos")),
    "SFM Grotto Deku Scrub Green Potion":              ("GrottoNPC",   0xEE,  0x3A, None,                     ("Sacred Forest Meadow", "Forest", "Deku Scrub", "Grottos")),
    "LH Grotto Deku Scrub Deku Nuts":                  ("GrottoNPC",   0xEF,  0x30, None,                     ("Lake Hylia", "Deku Scrub", "Grottos")),
    "LH Grotto Deku Scrub Bombs":                      ("GrottoNPC",   0xEF,  0x37, None,                     ("Lake Hylia", "Deku Scrub", "Grottos")),
    "LH Grotto Deku Scrub Arrows":                     ("GrottoNPC",   0xEF,  0x33, None,                     ("Lake Hylia", "Deku Scrub", "Grottos")),
    "Valley Grotto Deku Scrub Red Potion":             ("GrottoNPC",   0xF0,  0x39, None,                     ("Gerudo Valley", "Gerudo", "Deku Scrub", "Grottos")),
    "Valley Grotto Deku Scrub Green Potion":           ("GrottoNPC",   0xF0,  0x3A, None,                     ("Gerudo Valley", "Gerudo", "Deku Scrub", "Grottos")),
    "LW Deku Scrub Deku Nuts":                         ("NPC",         0x5B,  0x30, None,                     ("the Lost Woods", "Forest", "Deku Scrub")),
    "LW Deku Scrub Deku Sticks":                       ("NPC",         0x5B,  0x31, None,                     ("the Lost Woods", "Forest", "Deku Scrub")),
    "LW Deku Scrub Deku Stick Upgrade":                ("NPC",         0x5B,  0x77, None,                     ("the Lost Woods", "Forest", "Deku Scrub", "Deku Scrub Upgrades")),
    "LW Grotto Deku Scrub Arrows":                     ("GrottoNPC",   0xF5,  0x33, None,                     ("the Lost Woods", "Forest", "Deku Scrub", "Grottos")),
    "LW Grotto Deku Scrub Deku Nut Upgrade":           ("GrottoNPC",   0xF5,  0x79, None,                     ("the Lost Woods", "Forest", "Deku Scrub", "Deku Scrub Upgrades", "Grottos")),
    "Desert Grotto Deku Scrub Red Potion":             ("GrottoNPC",   0xFD,  0x39, None,                     ("Desert Colossus", "Deku Scrub", "Grottos")),
    "Desert Grotto Deku Scrub Green Potion":           ("GrottoNPC",   0xFD,  0x3A, None,                     ("Desert Colossus", "Deku Scrub", "Grottos")),
    "DMC Deku Scrub Bombs":                            ("NPC",         0x61,  0x37, None,                     ("Death Mountain Crater", "Death Mountain", "Deku Scrub")),
    "DMC Grotto Deku Scrub Deku Nuts":                 ("GrottoNPC",   0xF9,  0x30, None,                     ("Death Mountain Crater", "Death Mountain", "Deku Scrub", "Grottos")),
    "DMC Grotto Deku Scrub Bombs":                     ("GrottoNPC",   0xF9,  0x37, None,                     ("Death Mountain Crater", "Death Mountain", "Deku Scrub", "Grottos")),
    "DMC Grotto Deku Scrub Arrows":                    ("GrottoNPC",   0xF9,  0x33, None,                     ("Death Mountain Crater", "Death Mountain", "Deku Scrub", "Grottos")),
    "Goron Grotto Deku Scrub Deku Nuts":               ("GrottoNPC",   0xFB,  0x30, None,                     ("Goron City", "Deku Scrub", "Grottos")),
    "Goron Grotto Deku Scrub Bombs":                   ("GrottoNPC",   0xFB,  0x37, None,                     ("Goron City", "Deku Scrub", "Grottos")),
    "Goron Grotto Deku Scrub Arrows":                  ("GrottoNPC",   0xFB,  0x33, None,                     ("Goron City", "Deku Scrub", "Grottos")),
    "LLR Grotto Deku Scrub Deku Nuts":                 ("GrottoNPC",   0xFC,  0x30, None,                     ("Lon Lon Ranch", "Deku Scrub", "Grottos")),
    "LLR Grotto Deku Scrub Bombs":                     ("GrottoNPC",   0xFC,  0x37, None,                     ("Lon Lon Ranch", "Deku Scrub", "Grottos")),
    "LLR Grotto Deku Scrub Arrows":                    ("GrottoNPC",   0xFC,  0x33, None,                     ("Lon Lon Ranch", "Deku Scrub", "Grottos")),

    "LLR Stables Left Cow":                            ("NPC",         0x36,  0x15, None,                     ("Lon Lon Ranch", "Cow",)),
    "LLR Stables Right Cow":                           ("NPC",         0x36,  0x16, None,                     ("Lon Lon Ranch", "Cow",)),
    "LLR Tower Right Cow":                             ("NPC",         0x4C,  0x15, None,                     ("Lon Lon Ranch", "Cow",)),
    "LLR Tower Left Cow":                              ("NPC",         0x4C,  0x16, None,                     ("Lon Lon Ranch", "Cow",)),
    "Links House Cow":                                 ("NPC",         0x34,  0x15, None,                     ("Links House", "Forest", "Cow", "Minigames")),
    "Impas House Cow":                                 ("NPC",         0x37,  0x15, None,                     ("Kakariko Village", "Kakariko", "Cow")),
    "Gerudo Valley Cow":                               ("NPC",         0x5A,  0x15, None,                     ("Gerudo Valley", "Gerudo", "Cow")),
    "DMT Grotto Cow":                                  ("NPC",         0x3E,  0x15, None,                     ("Death Mountain Trail", "Death Mountain", "Cow", "Grottos")),
    "HF Grotto Cow":                                   ("NPC",         0x3E,  0x16, None,                     ("Hyrule Field", "Cow", "Grottos")),

    # These are not actual locations, but are filler spots used for hint reachability
    "Death Mountain Crater Gossip Stone":              ("GossipStone", None,  None, None,                     None),
    "Death Mountain Trail Gossip Stone":               ("GossipStone", None,  None, None,                     None),
    "Desert Colossus Gossip Stone":                    ("GossipStone", None,  None, None,                     None),
    "Dodongos Cavern Gossip Stone":                    ("GossipStone", None,  None, None,                     None),
    "Gerudo Valley Gossip Stone":                      ("GossipStone", None,  None, None,                     None),
    "Goron City Maze Gossip Stone":                    ("GossipStone", None,  None, None,                     None),
    "Goron City Medigoron Gossip Stone":               ("GossipStone", None,  None, None,                     None),
    "Graveyard Gossip Stone":                          ("GossipStone", None,  None, None,                     None),
    "Hyrule Castle Malon Gossip Stone":                ("GossipStone", None,  None, None,                     None),
    "Hyrule Castle Rock Wall Gossip Stone":            ("GossipStone", None,  None, None,                     None),
    "Castle Storms Grotto Gossip Stone":               ("GossipStone", None,  None, None,                     None),
    "Field Valley Grotto Gossip Stone":                ("GossipStone", None,  None, None,                     None),
    "Deku Tree Gossip Stone (Left)":                   ("GossipStone", None,  None, None,                     None),
    "Deku Tree Gossip Stone (Right)":                  ("GossipStone", None,  None, None,                     None),
    "Kokiri Forest Gossip Stone":                      ("GossipStone", None,  None, None,                     None),
    "Lake Hylia Lab Gossip Stone":                     ("GossipStone", None,  None, None,                     None),
    "Lake Hylia Gossip Stone (Southeast)":             ("GossipStone", None,  None, None,                     None),
    "Lake Hylia Gossip Stone (Southwest)":             ("GossipStone", None,  None, None,                     None),
    "Lost Woods Gossip Stone":                         ("GossipStone", None,  None, None,                     None),
    "Sacred Forest Meadow Maze Gossip Stone (Lower)":  ("GossipStone", None,  None, None,                     None),
    "Sacred Forest Meadow Maze Gossip Stone (Upper)":  ("GossipStone", None,  None, None,                     None),
    "Sacred Forest Meadow Saria Gossip Stone":         ("GossipStone", None,  None, None,                     None),
    "Temple of Time Gossip Stone (Left)":              ("GossipStone", None,  None, None,                     None),
    "Temple of Time Gossip Stone (Left-Center)":       ("GossipStone", None,  None, None,                     None),
    "Temple of Time Gossip Stone (Right)":             ("GossipStone", None,  None, None,                     None),
    "Temple of Time Gossip Stone (Right-Center)":      ("GossipStone", None,  None, None,                     None),
    "Zoras Domain Gossip Stone":                       ("GossipStone", None,  None, None,                     None),
    "Zoras Fountain Fairy Gossip Stone":               ("GossipStone", None,  None, None,                     None),
    "Zoras Fountain Jabu Gossip Stone":                ("GossipStone", None,  None, None,                     None),
    "Zoras River Plateau Gossip Stone":                ("GossipStone", None,  None, None,                     None),
    "Zoras River Waterfall Gossip Stone":              ("GossipStone", None,  None, None,                     None),

    "Field West Castle Town Grotto Gossip Stone":      ("GossipStone", None,  None, None,                     None),
    "Remote Southern Grotto Gossip Stone":             ("GossipStone", None,  None, None,                     None),
    "Field Near Lake Outside Fence Grotto Gossip Stone":("GossipStone",None,  None, None,                     None),
    "Kakariko Back Grotto Gossip Stone":               ("GossipStone", None,  None, None,                     None),
    "Zora River Plateau Open Grotto Gossip Stone":     ("GossipStone", None,  None, None,                     None),
    "Kokiri Forest Storms Grotto Gossip Stone":        ("GossipStone", None,  None, None,                     None),
    "Lost Woods Generic Grotto Gossip Stone":          ("GossipStone", None,  None, None,                     None),
    "Mountain Storms Grotto Gossip Stone":             ("GossipStone", None,  None, None,                     None),
    "Top of Crater Grotto Gossip Stone":               ("GossipStone", None,  None, None,                     None),

    "Ganondorf Hint":                                  ("GossipStone", None,  None, None,                     None),
}

# Business Scrub Details
business_scrubs = [
    # id   price  text   text replacement
    (0x30, 20,   0x10A0, ["Deku Nuts", "a \x05\x42mysterious item\x05\x40"]),
    (0x31, 15,   0x10A1, ["Deku Sticks", "a \x05\x42mysterious item\x05\x40"]),
    (0x3E, 10,   0x10A2, ["Piece of Heart", "\x05\x42mysterious item\x05\x40"]),
    (0x33, 40,   0x10CA, ["\x05\x41Deku Seeds", "a \x05\x42mysterious item"]),
    (0x34, 50,   0x10CB, ["\x41Deku Shield", "\x42mysterious item"]),
    (0x37, 40,   0x10CC, ["\x05\x41Bombs", "a \x05\x42mysterious item"]),
    (0x38, 00,   0x10CD, ["\x05\x41Arrows", "a \x05\x42mysterious item"]),  # unused
    (0x39, 40,   0x10CE, ["\x05\x41Red Potion", "\x05\x42mysterious item"]),
    (0x3A, 40,   0x10CF, ["Green Potion", "mysterious item"]),
    (0x77, 40,   0x10DC, ["enable you to pick up more\x01\x05\x41Deku Sticks", "sell you a \x05\x42mysterious item"]),
    (0x79, 40,   0x10DD, ["enable you to pick up more \x05\x41Deku\x01Nuts", "sell you a \x05\x42mysterious item"]),
]

dungeons = ('Deku Tree', 'Dodongo\'s Cavern', 'Jabu Jabu\'s Belly', 'Forest Temple', 'Fire Temple', 'Water Temple', 'Spirit Temple', 'Shadow Temple', 'Ice Cavern', 'Bottom of the Well', 'Gerudo Training Grounds', 'Ganon\'s Castle')
location_groups = {
    'Song': [name for (name, data) in location_table.items() if data[0] == 'Song'],
    'Chest': [name for (name, data) in location_table.items() if data[0] == 'Chest'],
    'Collectable': [name for (name, data) in location_table.items() if data[0] == 'Collectable'],
    'BossHeart': [name for (name, data) in location_table.items() if data[0] == 'BossHeart'],
    'CollectableLike': [name for (name, data) in location_table.items() if data[0] in ('Collectable', 'BossHeart', 'GS Token')],
    'CanSee': [name for (name, data) in location_table.items() if data[0] in ('Collectable', 'BossHeart', 'GS Token', 'Shop')],
    'Dungeon': [name for (name, data) in location_table.items() if data[4] is not None and any(dungeon in data[4] for dungeon in dungeons)],
}


# Function to run exactly once after after placing items in drop locations for each world
# Sets all Drop locations to a unique name in order to avoid name issues and to identify locations in the spoiler
def set_drop_location_names(world):
    for location in world.get_locations():
        if location.type == 'Drop':
            location.name = location.parent_region.name + " " + location.name
